//
//  NSImage+additions.m
//  MakeupMirror
//
//  Created by David Phillip Oster on 3/20/09.
//  Copyright 2009 David Phillip Oster. All rights reserved.
//
#import "NSImage+additions.h"

@implementation NSImage(additions)


- (NSImage *)grayedOut {
  NSSize size = [self size];
  NSRect bounds = NSMakeRect(0, 0, size.width, size.height);
  NSBitmapImageRep *bitmapImageRep = 
    [[[NSBitmapImageRep alloc] initWithBitmapDataPlanes:NULL 
                                             pixelsWide:size.width 
                                             pixelsHigh:size.height 
                                          bitsPerSample:8 
                                        samplesPerPixel:4 
                                               hasAlpha:YES 
                                               isPlanar:NO 
                                         colorSpaceName:NSDeviceRGBColorSpace 
                                            bytesPerRow:0 
                                           bitsPerPixel:0] autorelease];
  NSGraphicsContext *nsContext = [NSGraphicsContext graphicsContextWithBitmapImageRep:bitmapImageRep];
  [NSGraphicsContext saveGraphicsState];
  [NSGraphicsContext setCurrentContext:nsContext];
  [[NSColor clearColor] set];
  [NSBezierPath fillRect:bounds];
  [self dissolveToPoint:NSZeroPoint fraction:0.4];
  [NSGraphicsContext restoreGraphicsState];
  NSImage *result = [[[NSImage alloc] initWithSize:size] autorelease];
  [result addRepresentation:bitmapImageRep];
  return result;
}

- (NSImage *)stampedWith:(NSImage *)stamp {
  NSSize size = [self size];
  NSBitmapImageRep *bitmapImageRep = 
    [[[NSBitmapImageRep alloc] initWithBitmapDataPlanes:NULL 
                                             pixelsWide:size.width 
                                             pixelsHigh:size.height 
                                          bitsPerSample:8 
                                        samplesPerPixel:4 
                                               hasAlpha:YES 
                                               isPlanar:NO 
                                         colorSpaceName:NSDeviceRGBColorSpace 
                                            bytesPerRow:0 
                                           bitsPerPixel:0] autorelease];
  NSGraphicsContext *nsContext = [NSGraphicsContext graphicsContextWithBitmapImageRep:bitmapImageRep];
  [NSGraphicsContext saveGraphicsState];
  [NSGraphicsContext setCurrentContext:nsContext];
  [self compositeToPoint:NSZeroPoint operation:NSCompositeCopy];
  [stamp compositeToPoint:NSZeroPoint operation:NSCompositeSourceOver];
  [NSGraphicsContext restoreGraphicsState];
  NSImage *result = [[[NSImage alloc] initWithSize:size] autorelease];
  [result addRepresentation:bitmapImageRep];
  return result;
}


@end
